"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.exec = exports.copyDir = void 0;
const fs_1 = __importStar(require("fs"));
const path_1 = __importDefault(require("path"));
const child_process_1 = require("child_process");
exports.copyDir = (src, dest) => {
    if (!fs_1.existsSync(dest))
        fs_1.mkdirSync(dest);
    const files = fs_1.default.readdirSync(src);
    for (let i = 0; i < files.length; i++) {
        const current = fs_1.default.lstatSync(path_1.default.join(src, files[i]));
        if (current.isDirectory()) {
            exports.copyDir(path_1.default.join(src, files[i]), path_1.default.join(dest, files[i]));
        }
        else if (current.isSymbolicLink()) {
            const symlink = fs_1.default.readlinkSync(path_1.default.join(src, files[i]));
            fs_1.default.symlinkSync(symlink, path_1.default.join(dest, files[i]));
        }
        else {
            fs_1.copyFileSync(path_1.default.join(src, files[i]), path_1.default.join(dest, files[i]));
        }
    }
};
exports.exec = (command, options = {}) => {
    return new Promise((relove, reject) => {
        var _a, _b;
        const p = child_process_1.exec(command, { cwd: options.cdw || process.cwd() });
        (_a = p.stdout) === null || _a === void 0 ? void 0 : _a.on("data", data => process.stdout.write(`${data}`));
        (_b = p.stderr) === null || _b === void 0 ? void 0 : _b.on("data", data => process.stderr.write(`${data}`));
        p.on("error", reject);
        p.on("exit", relove);
    });
};
